#include <stdio.h>
#include "tsList.h"

// Ver 3.5.16.7  RgAEg
#define PID_MAX		8192

NOT_PID NOTMATCH[PID_MAX];
int svNO1;
int svNO2;
// Ver 3.5.16.7  RgAEg

// Xgɗvfo^ido^͂Ȃ)
bool insertList(struct tsLIST* head, int data )
{
	//Ver3.5.16.7---------------------------------------------------------
	//struct tsLIST* p, *q, *newcell;
	struct tsLIST *p, *q, *newcell;
	//-------------------------------------------------------------------
	p = head->next;
	while( p != NULL )
	{
		//Ver3.5.16.7----------------------------------------------------
		q = p;
		//---------------------------------------------------------------
		if( p->PID == data )
			return true;
		
		//Ver3.5.16.7---------------------------------------------------
		//if(  p->PID < data )
		//	break;
		//q = p;
		if(  data < p->PID )
			break;
		//---------------------------------------------------------------
		p = p->next;
	}

	newcell = (struct tsLIST* )malloc( sizeof(struct tsLIST) );
	if( newcell == NULL )
	{
		fprintf(stderr,"̊mۂɎs܂\n");
		fflush(stderr);
		return false;
	}

	newcell->PID = data;
	newcell->next = NULL;
	if( head->next == NULL ){
		head->next = newcell;
	}
	else{
		q->next = newcell;
		if( p != NULL ){
			newcell->next = p;
		}
	}
	return true;

}

// Xg폜
void clearList(struct tsLIST* head)
{
	struct tsLIST *q;
	
	while( head->next != NULL )
	{
		q = head->next;
		head->next = q->next;
		free(q);
	}

}

// Xgo^Ԃ
int countList( struct tsLIST* head )
{
	struct tsLIST *p;
	int i = 0;

	for( p = head->next ; p != NULL; p = p->next, i++ )
		;

	return i;

}

// Xg̓eԂ
int getList( struct tsLIST* head , int i )
{
	struct tsLIST *p;
	int count = 0;

	for( p = head->next; p != NULL; p = p->next, count++ )
	{
		if( i == count )
			return p->PID;
	}
	return 0;
}

// Xgɑ݂邩
bool findList( struct tsLIST* head , int PID )
{
	struct tsLIST *p;
	int i = 0;
	for( p = head->next; p != NULL; p = p->next, i++ ){
		if( p->PID == PID )
			return true;
	}
	return false;

}

// Ver 3.5.16.7  RgAEg
//Xĝ
bool isEqualsList( struct tsLIST* head1, struct tsLIST* head2 )
{
	struct tsLIST *p;
	for( p = head1->next; p != NULL; p = p->next ){
		if( !findList( head2, p->PID ))
			return false;
	}
	if( countList( head1 ) != countList( head2 ))
		return false;

	return true;

}
//XgňvȂPIDԂ
bool findFirstNoMatchPID( struct tsLIST* head1, struct tsLIST* head2, int* PID1, int* PID2 )
{
	int i;
	for( i = 0; i < 8192; i++ ){
		NOTMATCH[i].PID1 = -1;
		NOTMATCH[i].PID2 = -1;
	}
	
	i = countList( head1 );
	int j;
	for( j = 0; j < i; j++ )
		NOTMATCH[j].PID1 = getList( head1, j );

	i = countList( head2 );
	for( j = 0; j < i; j++ )
		NOTMATCH[j].PID2 = getList( head2, j );

	i = 0;
	j = 0;
	do{
		while( NOTMATCH[j].PID2 != -1 ){
			if( NOTMATCH[i].PID1 == NOTMATCH[j].PID2 ){
				NOTMATCH[i].PID1 = 0;
				NOTMATCH[j].PID2 = 0;
				break;
			}
			j++;
		}
		i++;
	}while( NOTMATCH[i].PID1 != -1 );

	i = countList( head1 );
	for( j = 0; j < i; j++ ){
		if( 0 < NOTMATCH[j].PID1 || -1 == NOTMATCH[j].PID1 )
			break;
	}
	svNO1 = j;
	*PID1 = NOTMATCH[j].PID1;

	i = countList( head2 );
	for( j = 0; j < i; j++ ){
		if( 0 < NOTMATCH[j].PID2 || -1 == NOTMATCH[j].PID2 )
			break;
	}
	svNO2 = j;
	*PID2 = NOTMATCH[j].PID2;

	if( *PID1 == -1 && *PID2 == -1 )
		return false;

	if( *PID1 == -1 )	*PID1 = 0;
	if( *PID2 == -1 )	*PID2 = 0;

	return true;

}


bool nextNoMatchPID( int* PID1, int* PID2)
{
	int i = svNO1 + 1;
	while( -1 < NOTMATCH[i].PID1 ){
		if( 0 < NOTMATCH[i].PID1 ){
			break;
		}
		i++;
	}
	svNO1 = i;
	*PID1 = NOTMATCH[i].PID1;

	i = svNO2 + 1;
	while( -1 < NOTMATCH[i].PID2 ){
		if( 0 < NOTMATCH[i].PID2 ){
			break;
		}
		i++;
	}
	svNO2 = i;
	*PID2 = NOTMATCH[i].PID2;

	if( *PID1 == -1 && *PID2 == -1 )
		return false;

	if( *PID1 == -1 )	*PID1 = 0;
	if( *PID1 == -1 )	*PID2 = 0;

	return true;

}
// Ver 3.5.16.7  RgAEg
