
// TsTimeKeeper.cpp : R\[ AvP[ṼGg |Cg`܂B
// Ver 3.5.16.7
#include <stdio.h>
#include <stdlib.h>
#include <windows.h>
#include <shlwapi.h>
#include <string>
#include "tsList.h"
#include "tsPacket.h"
#include "tsFileRead.h"
#include "tsTimeKeeper.h"

// Ver 3.5.16.7  ǉ
#define DEFAULT_INI "[Default]\r\n\
nogop='off'\r\n\
pmtcheck='off'\r\n\
log='off'\r\n"
// Ver 3.5.16.7 

#define PID_MAX		8192

// 萔
const int nvideoSize = 188 * 4096 * 3;

// Ver 3.5.16.7  (C-PTS Cp) ǉ
__int64 CAPTIONstartPTS = 0;
int CAPTIONstartFlag = true;
// Ver 3.5.16.7  (C-PTS Cp)

paraMODE param;
FILE *fpLog = NULL;

// C
int _tmain(int argc, _TCHAR* argv[])
{
	tsPACKET tsp;
	TCHAR *pFileName = NULL;
	TCHAR *pTargetFileName = NULL;
	TCHAR *pLogFileName = NULL;

	//init@CpX擾
	TCHAR pIniFileName[_MAX_PATH];
	memset(pIniFileName, 0x00, sizeof(pIniFileName));
	//s̃vZX̃tpX擾
	DWORD dwRet = GetModuleFileName(NULL, pIniFileName, sizeof(pIniFileName));
	if(dwRet == 0) {
	//G[Ȃ(ȗ)
		exit(1);
	}else {
		TCHAR *pExt = PathFindExtension(pIniFileName);
		_tcscpy_s(pExt,5,_T(".ini"));//_MAX_EXT
	}
	// Open ini File
	FILE *fpIni;
	_tfopen_s( &fpIni, pIniFileName, _T("r"));
	if( !fpIni ) {
		FILE *fpIni;
		_tfopen_s( &fpIni, pIniFileName, _T("wb"));
		fprintf(fpIni, "%s", DEFAULT_INI);
		fclose(fpIni);
	}
	else {
		fclose( fpIni );
	}
	TCHAR *tmpBuff;
	tmpBuff = new TCHAR[256];
	memset(tmpBuff, 0, sizeof(TCHAR) * 256);
// Ver 3.5.16.7  ǉ
	GetPrivateProfileString(_T("Default"),_T("nogop"),_T("off"),tmpBuff,256,pIniFileName);
	if (_tcsicmp(tmpBuff, _T("off")) == 0) {
		param.bNoGOP = FALSE;
	}else {
		param.bNoGOP = TRUE;
	}
// Ver 3.5.16.7  RgAEg
	GetPrivateProfileString(_T("Default"),_T("pmtcheck"),_T("off"),tmpBuff,256,pIniFileName);
	if (_tcsicmp(tmpBuff, _T("off")) == 0) {
		param.bPMTchk = FALSE;
	}else {
		param.bPMTchk = TRUE;
	}
// Ver 3.5.16.7  RgAEg
	GetPrivateProfileString(_T("Default"),_T("log"),_T("off"),tmpBuff,256,pIniFileName);
	if (_tcsicmp(tmpBuff, _T("off")) == 0) {
		param.bLogMode = FALSE;
	}else {
		param.bLogMode = TRUE;
	}

	//p[^`FbN
	if ( argc == 1 ){//Kg̖On̂łꂪ Ȃ (argc < 1) œ񂾂낤?
ERROR_PARAM:
// Ver 3.5.16.7  ύX
		fprintf(stderr,"TsTimeKeeper Ver3.5.16.7(32bit) Kai (fix C-PTS) r2\n\n");
		fprintf(stderr,"usage\n");
		fprintf(stderr,"TsTimeKeeper.exe [OPTIONS] source.ts [destination.ts]\n");
		fprintf(stderr,"     [OPTIONS]\n");
// Ver 3.5.16.7  ǉ
		fprintf(stderr,"          -nogop {on|off}     : no-check GOP start\n");
		fprintf(stderr,"          -pmtcheck {on|off}  : check PMT change\n");
// Ver 3.5.16.7 
		fprintf(stderr,"          -log {on|off}       : make log-file\n");
		TCHAR s[256];
		fprintf(stderr,"\n\n");
		fprintf(stderr,"EnterL[ĉ...");
		fscanf_s(stdin,"%c",s);
		return( 0 );
	}
	for (int i = 1; i < argc; i++) {
		if (_tcsicmp(argv[i], _T("-i")) == 0) {
			if ( ++i > argc )
				goto ERROR_PARAM;
			pFileName = argv[i];
			continue;
		}
		else if (_tcsicmp(argv[i], _T("-o")) == 0) {
			if ( ++i > argc )
				goto ERROR_PARAM;
			pTargetFileName = argv[i];
			continue;
		}
// Ver 3.5.16.7  ǉ
		else if (_tcsicmp(argv[i], _T("-nogop")) == 0) {
			if ( ++i > argc )
				goto ERROR_PARAM;
			if (_tcsicmp(argv[i], _T("on")) == 0) {
				param.bNoGOP = TRUE;
			}else if (_tcsicmp(argv[i], _T("off")) == 0) {
				param.bNoGOP = FALSE;
			}else
				goto ERROR_PARAM;
			continue;
		}
// Ver 3.5.16.7  RgAEg
		else if (_tcsicmp(argv[i], _T("-pmtcheck")) == 0) {
			if ( ++i > argc )
				goto ERROR_PARAM;
			if (_tcsicmp(argv[i], _T("on")) == 0) {
				param.bPMTchk = TRUE;
			}else if (_tcsicmp(argv[i], _T("off")) == 0) {
				param.bPMTchk = FALSE;
			}else
				goto ERROR_PARAM;
			continue;
		}
// Ver 3.5.16.7  RgAEg
		else if (_tcsicmp(argv[i], _T("-log")) == 0) {
			if ( ++i > argc )
				goto ERROR_PARAM;
			if (_tcsicmp(argv[i], _T("on")) == 0) {
				param.bLogMode = TRUE;
			}else if (_tcsicmp(argv[i], _T("off")) == 0) {
				param.bLogMode = FALSE;
			}else
				goto ERROR_PARAM;
			continue;
		}
		if (!pFileName) {
			pFileName = argv[i];
			continue;
		}
		if (!pTargetFileName) {
			pTargetFileName = argv[i];
			continue;
		}
	}
	if( !pFileName ) {
		goto ERROR_PARAM;
	}else {
		TCHAR *pExt = PathFindExtension(pFileName);
		if(_tcsicmp(pExt, _T(".ts")) != 0){
			goto ERROR_PARAM;
		}
	}
	if( !pTargetFileName ) {
		pTargetFileName = new TCHAR[MAX_PATH];
		memset(pTargetFileName, 0, sizeof(TCHAR) * MAX_PATH);
		_tcscat_s(pTargetFileName,MAX_PATH, pFileName);
		TCHAR *pExt = PathFindExtension(pTargetFileName);
		_tcscpy_s(pExt,8,_T(".000.ts"));
	}else {
		if(_tcsicmp(pFileName, pTargetFileName) == 0){
			goto ERROR_PARAM;
		}
	}

	tsp.nVideo = ( byte* )malloc((size_t)(nvideoSize));
	if( tsp.nVideo == NULL ){
		fprintf( stderr, "Ǎ݃obt@̊mۂɎs܂.\n" );
		return false;
	}

	tsp.roundCounter = ( int* )malloc( sizeof( int ) * PID_MAX );
	if( tsp.roundCounter == NULL ){
		fprintf( stderr, "JE^̊mۂɎs܂.\n" );
		free( tsp.nVideo );
		return false;
	}

	tsp.bGOP = false;
	tsp.nowValueGOPPTS = 0;
	tsp.nowValuePCR = 0;
	tsp.numGOP = 0;
	tsp.startPCR = 324000000LL * 300;

	initList( &tsp );

	SYSTEMTIME stTime;
	GetLocalTime(&stTime);

	fprintf( stdout, "Jn %02d%02d%02db\n", stTime.wHour, stTime.wMinute , stTime.wSecond );
	fflush( stdout );

	if( param.bLogMode ){
		pLogFileName = new TCHAR[MAX_PATH];
		memset(pLogFileName, 0, sizeof(TCHAR) * MAX_PATH);
		_tcscat_s(pLogFileName, MAX_PATH, pFileName);
		TCHAR *pExt = PathFindExtension(pLogFileName);
		_tcscpy_s(pExt,10, _T("_Time.log"));
		_tfopen_s( &fpLog, pLogFileName, _T("wb"));
		if( !fpLog ) {
			fprintf( stderr, "Open Log File: %s failed\n", pLogFileName );
			return false;
		}
	} else {
		fpLog = NULL;
	}

	tsFileRead	inpfile(pFileName);

	if( !getInfoFromFile(&inpfile, &tsp )){
		clearListMEM( &tsp );
		free( tsp.roundCounter );
		free( tsp.nVideo );
		return false;
	}

	tsp.bGOP = false;

	if( !timeKeep(&inpfile, pTargetFileName, &tsp )){
		clearListMEM( &tsp );
		free( tsp.roundCounter );
		free( tsp.nVideo );
		return false;
	}

	GetLocalTime( &stTime );

	fprintf( stdout,"I %02d%02d%02db\n", stTime.wHour, stTime.wMinute , stTime.wSecond );
	fflush( stdout );

	clearListMEM( &tsp );
	free( tsp.roundCounter );
	free( tsp.nVideo );
	if( fpLog ){
		fclose( fpLog );
	}
	return true;

}

// 
//   PAT,PMT,PCR
bool getInfoFromFile( tsFileRead* file, tsPACKET* tsp )
{
	int		readSize;
	int		nBuffPoint;
	bool	bPCR = false;

	fprintf( stdout, "PAT,PMT,PCR,GOP \n" );
	fflush( stdout );

	readSize = file->Read( tsp->nVideo, nvideoSize );

	nBuffPoint = -188;
	int count = 0;

// Ver 3.5.16.7  ǉ
	if (param.bNoGOP) {
		tsp->bGOP = true;
	}else {
		tsp->bGOP = false;
	}
// Ver 3.5.16.7 
	//bPCR = false;
	do{
		nBuffPoint += 188;

		if( readSize - 1 < nBuffPoint)
		{
			fprintf( stderr,"t@CjĂ\܂...I܂(INFO).\n" );
			fflush( stderr );
			return false;
		}
		
		//Ver3.5.16.7--------------------------------------------------------------
		// Payload exists
		//if( tsp->nVideo[nBuffPoint + 3] & 0x10 ){
		//	if( isPAT( tsp, nBuffPoint )){
		//		if( !getPATDATA( tsp, nBuffPoint ))
		//			return false;
		//	}else if( isPMT( tsp,nBuffPoint )){
		//		if( !getPMTDATA( tsp, nBuffPoint ))
		//			return false;
		//	}else{
		//		if( !getVADATA( tsp, nBuffPoint ))
		//			return false;
		//	}

		//}else if( isPCR( tsp, nBuffPoint )){

		if( isPAT( tsp, nBuffPoint )){
			if( !getPATDATA( tsp, nBuffPoint ))
				return false;
		}
		else if( isPMT( tsp,nBuffPoint )){
			if( !getPMTDATA( tsp, nBuffPoint ))
				return false;
		}
		else{
			if( !getVADATA( tsp, nBuffPoint ))
				return false;
		}
		if( isPCR( tsp, nBuffPoint )){
		//------------------------------------------------------------------------
			count++;
			switch( count ){
			case 1:
				if( !getPCRDATA( tsp, nBuffPoint )) 
					return false;
				break;

			case 2:		//2xo܂
				bPCR = true;
				break;

			}
		}
	}while( !bPCR );

	count = countList( &(tsp->VIDEO_PID) );
	switch( count )
	{
	case 0:
		fprintf(stderr,"f܂...I܂(INFO).\n");
		fflush(stderr);
		return false;
		break;

	case 1:	//Ȃ
		break;

	default:
		fprintf(stderr,"̉f܂܂Ă܂...ł܂(INFO). ");
		for( int i = 0; i < count; i++ )
			fprintf(stderr, " %d ", getList( &(tsp->VIDEO_PID), i ));
		fprintf(stderr,"\n");
		fflush(stderr);
		return false;
		break;

	}

	count =  countList( &(tsp->AUDIO_PID) );
	switch( count )
	{
	case 0:
		fprintf(stderr,"܂...I܂(INFO).\n");
		fflush(stderr);
		return false;
		break;

	case 1:
	case 2:
		break;	//Ȃ

	default:
		fprintf(stderr,"Oȏ̉܂܂Ă܂...ł܂(INFO). ");
		for( int i = 0; i < count; i++ )
			fprintf(stderr, " %d ", getList( &(tsp->AUDIO_PID), i ));
		fprintf(stderr,"\n");
		fflush(stderr);
		return false;
		break;

	}

	count = countList( &(tsp->CAPTION_PID) );
	switch( count )
	{
	case 0:
	case 1:
		break;

	default:
		break;

	}

	return true;

}

bool isPAT(tsPACKET* tsp, int nBuffPoint )
{
	int iPPID =	(( tsp->nVideo[nBuffPoint + 1] & 0x1f) << 8 ) + tsp->nVideo[nBuffPoint + 2];							// vOPID
	// vOPID"00"ȂPAT(e[u(00)+ZNVV^NXw(1)+0+11ȂPAT)
	if(0 == iPPID && 0xb == (tsp->nVideo[nBuffPoint + 5] << 4)+ ((tsp->nVideo[nBuffPoint + 6] & 0xf0) >> 4))		//e[u(00)+ZNVV^NXw(1)+0+1
		return true;
		
	return false;

}

bool getPATDATA( tsPACKET* tsp, int nBuffPoint )
{
	int secLength = (( tsp->nVideo[nBuffPoint + 6] & 0xf) << 8 ) + tsp->nVideo[nBuffPoint + 7] - 9;
	int offSet = 0;
	 
	while( offSet < secLength ){
		//ԑgԍ
		if( 0 != tsp->nVideo[nBuffPoint + offSet + 13] + tsp->nVideo[nBuffPoint + offSet + 14]){
			int PMTPID = ((tsp->nVideo[nBuffPoint + offSet + 15] & 0x1f) << 8 ) + tsp->nVideo[nBuffPoint + offSet + 16];
			if( !insertList( &(tsp->PMT_PID), PMTPID ))
				return false;
		}
		offSet += 4;
	}

	switch( countList( &(tsp->PMT_PID) )) {
	case 0:
		fprintf( stderr,"t@CjĂ\܂...I܂(PAT).\n" );
		fflush( stderr );
		return false;
		break;

	case 1:
		return true;
		break;

	default:
		fprintf( stderr,"̃T[rX܂܂Ă܂...ł܂(PAT).\n" );
		fflush( stderr );
		return false;
		break;

	}
}

bool isPMT(tsPACKET* tsp, int nBuffPoint )
{
	if( findList( &(tsp->PMT_PID), ((tsp->nVideo[nBuffPoint + 1] & 0x1f) << 8 ) + tsp->nVideo[nBuffPoint + 2] )){
		if( 0x2b == (tsp->nVideo[nBuffPoint + 5] << 4) + ((tsp->nVideo[nBuffPoint + 6] & 0xf0) >> 4))
			return true;
	}
	return false;
	
}	

bool getPMTDATA( tsPACKET* tsp, int nBuffPoint )
{
	int i= 0;
	if( nBuffPoint == 40984 )
		i++;

	if( !insertList( &(tsp->PCR_PID), (( tsp->nVideo[nBuffPoint + 13] & 0x1f) << 8 ) + tsp->nVideo[nBuffPoint + 14] ))
		return false;

	//e[u(5byte)
	//ZNV(6Byteډ4Bit+7Byte)
	int secLength = (( tsp->nVideo[nBuffPoint + 6] & 0xf) << 8) + tsp->nVideo[nBuffPoint + 7];
	int nBase = ((tsp->nVideo[nBuffPoint + 15] & 0xf) << 8) + tsp->nVideo[nBuffPoint + 16] + 17;
	//17 wb_[:4Byte + e[u:1byte + '1011'+ZNV:2Byte + ..7Byte.. + '1111'+ԑg:2Byte +1
	secLength -= (nBase - 4 );//CRC32

	int offSet = 0;
	while( offSet < secLength){
		//Xg[` 
		int stmID = tsp->nVideo[nBuffPoint + nBase + offSet];
		int tmpPID = ((tsp->nVideo[nBuffPoint + nBase + offSet + 1] & 0x1f) << 8) + tsp->nVideo[nBuffPoint + nBase + offSet + 2];
		//Ő錾Ȃ΃G[ɂȂ-------------------------
		bool bcomponent_tag;
		int iDescLen;
		//---------------------------------------------------
		switch( stmID ){
		case 2:		//f
			if( !insertList( &(tsp->VIDEO_PID), tmpPID ))
				return false;
			break;
			
		case 0xf:	//
			if( !insertList( &(tsp->AUDIO_PID), tmpPID ))
				return false;
			break;
			
		case 6:		//
			bcomponent_tag = false;
			iDescLen = ((tsp->nVideo[nBuffPoint + nBase + offSet + 3] & 0xf) << 8) + tsp->nVideo[nBuffPoint + nBase + offSet + 4];
			for( int i = 0; i < iDescLen - 2; i++ ){
				if (tsp->nVideo[nBuffPoint + nBase + offSet + i + 5] == 0x52 &&
					tsp->nVideo[nBuffPoint + nBase + offSet + i + 6] == 0x01 &&
					tsp->nVideo[nBuffPoint + nBase + offSet + i + 7] == 0x30 ) {
					bcomponent_tag = true;
					break;
				}
			}
			if( bcomponent_tag ){
				if( !insertList( &(tsp->CAPTION_PID), tmpPID ))
					return false;
			}
			break;

		default:
			break;
		}
		offSet += (((tsp->nVideo[nBuffPoint + nBase + offSet + 3] & 0xf) << 8) + tsp->nVideo[nBuffPoint + nBase + offSet + 4] + 5);
	}

	int count = countList( &(tsp->PCR_PID) );
	switch( count )
	{
	case 0:
		fprintf( stderr,"PCR܂...I܂(PMT).\n" );
		fflush( stderr );
		return false;
		break;

	case 1:	//Ȃ
		break;

	default:
		fprintf( stderr,"t@CjĂ\܂...I܂(PMT).\n" );
		fflush( stderr );
		return false;
		break;

	}
		
	count = countList( &(tsp->VIDEO_PID) );
	switch( count )
	{
	case 0:
		fprintf( stderr,"f܂...I܂(PMT).\n" );
		fflush( stderr );
		return false;
		break;

	case 1:	//Ȃ
		break;

	default:
		fprintf( stderr,"̉f܂܂Ă܂...ł܂(PMT)." );
		for( int i  = 0; i < count; i++ )
			fprintf( stderr, " %d ", getList( &(tsp->VIDEO_PID), i ));
		fprintf( stderr,"\n" );
		fflush( stderr );
		return false;
		break;

	}

	count = countList( &(tsp->AUDIO_PID) );
	switch( count )
	{
	case 0:
		fprintf( stderr,"܂...I܂(PMT).\n" );
		fflush( stderr );
		return false;
		break;

	case 1:
	case 2:
		break;	//Ȃ

	default:
		fprintf( stderr,"Oȏ̉܂܂Ă܂...ł܂(PMT)." );
		for( int i = 0; i < count; i++ )
			fprintf( stderr, " %d ", getList( &(tsp->AUDIO_PID), i ));
		fprintf( stderr, "\n" );
		fflush( stderr );
		return false;
		break;

	}

	count = countList( &(tsp->CAPTION_PID) );
	switch( count )
	{
	case 0:
		break;

	case 1:
		break;

	default:
		break;

	}
	
	return true;

}

bool getVADATA( tsPACKET* tsp, int nBuffPoint )
{
	int iPPID =	((tsp->nVideo[nBuffPoint + 1] & 0x1f) << 8 ) + tsp->nVideo[nBuffPoint + 2];	// vOPID

	if ( tsp->nVideo[nBuffPoint + 3] & 0x10 ){	// payload exists
		//A_ve[VĂpPbg
		int	adpBytes = 0;
		if(tsp->nVideo[nBuffPoint + 3] & 0x20){
			adpBytes = tsp->nVideo[nBuffPoint + 4] + 1;
		}
		//pPbgX^[gR[h(000001)
		if( 0 == tsp->nVideo[nBuffPoint + adpBytes + 4] + tsp->nVideo[nBuffPoint + adpBytes + 5] ){
			if( 1 == tsp->nVideo[nBuffPoint + adpBytes + 6] && 0x80 == (tsp->nVideo[nBuffPoint + adpBytes + 10] & 0xc0)){
				int x = tsp->nVideo[nBuffPoint + adpBytes + 7];   //streamID
				if( (x & 0xf0) == 0xe0 ){				//f
					if( !insertList( &(tsp->VIDEO_PID), iPPID ))
						return false;
					//x = tsp->nVideo[nBuffPoint + adpBytes + 11] & 0xc0;	//PTS=&H80 DTS=&H40
					//If nVideo(nBuffPoint + adpBytes + 13) And &HF0 Then	'4bit 0010 PTS only   0011 DTS follows
					if( (tsp->nVideo[nBuffPoint + adpBytes + 11] & 0xc0) == 0xc0 )	//PTS=&H80 DTS=&H40
						tsp->bGOP = true;
						
				}
				else if( (x & 0xe0) == 0xc0 ){			//
					if( !insertList( &(tsp->AUDIO_PID), iPPID ))
						return false;
						
				}
			}
		}

		if( !tsp->bGOP ){
			fprintf(stderr,"t@C̐擪GOPŋ؂Ă܂...I܂.\n");
			fflush(stderr);
			return false;
		}
	}

	return true;

}

bool isPCR( tsPACKET* tsp, int nBuffPoint )
{
	int i=0;
	if(nBuffPoint == 46812 )
		i++;

	if( findList( &(tsp->PCR_PID), ((tsp->nVideo[nBuffPoint + 1] & 0x1f) << 8 ) + tsp->nVideo[nBuffPoint + 2] )){
		//		adaptation field exists					PCR flag 
		if(( tsp->nVideo[nBuffPoint + 3] & 0x20 ) && ( tsp->nVideo[nBuffPoint + 5] & 0x10 ))
			return true;
	}
	return false;

}

bool getPCRDATA( tsPACKET* tsp, int nBuffPoint )
{
	//'Ԏ擾
	tsp->difValueGOPPTSBASE = (getValuePCR(tsp->nVideo, nBuffPoint) - tsp->startPCR) / 300;
	return true;

}

bool timeKeep(tsFileRead* inpfile, _TCHAR* destName, tsPACKET* tsp )
{
	tsFileWrite	outfile( destName );
	__int64 fSize = inpfile->Size();
	__int64	nFilePoint;
	int		nBuffPoint;
	int		readSize;

	bool	foundPCR;
	bool	foundPTS;
	bool	foundGOP;

// Ver 3.5.16.7  RgAEg
	tsLIST	wkPCR_PID;
	tsLIST	wkVIDEO_PID;
	tsLIST	wkAUDIO_PID;
	tsLIST	wkCAPTION_PID;
// Ver 3.5.16.7  RgAEg

	int nowPercent = -1;
	int newPercent;
	int iPPID;

	nBuffPoint = -188;
	nFilePoint = -188;

	for( int i = 0; i < PID_MAX; i++ ){
		tsp->roundCounter[i] = -1;
	}

 	readSize = nvideoSize;
	fprintf(stdout,"PCR,PTS,DTS XV@ 0%% \r" );
	fflush(stdout);

	while( 1 ){
		newPercent =(int)((nFilePoint * 100) / fSize);
		if( nowPercent != newPercent ){
			nowPercent = newPercent;
			fprintf(stdout,"PCR,PTS,DTS XV@ %d%% \r", nowPercent);
			fflush(stdout);
		}

		do{
			nBuffPoint += 188;
			nFilePoint += 188;

			if(( readSize - 1 < nBuffPoint )){
				//
				outfile.Write(tsp->nVideo, readSize);
				//Ǎ
				readSize = inpfile->Read(tsp->nVideo, nvideoSize);

				nBuffPoint = 0;
				if( 0 == readSize ){
					fprintf(stdout,"PCR,PTS,DTS XV 100%% \n");
					fflush(stdout);
					break;
				}
			}

			foundPCR = false;
			foundGOP = false;
			foundPTS = false;

			iPPID = ((tsp->nVideo[nBuffPoint + 1] & 0x1f) << 8 ) + tsp->nVideo[nBuffPoint + 2] ;
			//@JE^C
			if(( tsp->nVideo[nBuffPoint + 3] & 0x10 )){		// Payload exists
				tsp->roundCounter[iPPID]++;
				if( 15 < tsp->roundCounter[iPPID] ){
					tsp->roundCounter[iPPID] = 0;
				}
			}else{
				if( tsp->roundCounter[iPPID] < 0 ){
					tsp->roundCounter[iPPID] = 0;
				}
			}
			tsp->nVideo[nBuffPoint + 3] = (tsp->nVideo[nBuffPoint + 3] & 0xf0) + tsp->roundCounter[iPPID];

// Ver 3.5.16.7  RgAEg
			// PMT̓eςĂȂ
			if( isPMT( tsp, nBuffPoint ) && param.bPMTchk ){
				wkPCR_PID.next = tsp->PCR_PID.next;
				wkVIDEO_PID.next = tsp->VIDEO_PID.next;
				wkAUDIO_PID.next = tsp->AUDIO_PID.next;
				wkCAPTION_PID.next = tsp->CAPTION_PID.next;
				tsp->PCR_PID.next = NULL;
				tsp->VIDEO_PID.next = NULL;
				tsp->AUDIO_PID.next = NULL;
				tsp->CAPTION_PID.next = NULL;
				if( !getPMTDATA( tsp, nBuffPoint )){
					clearList( &wkPCR_PID );
					clearList( &wkVIDEO_PID );
					clearList( &wkAUDIO_PID );
					clearList( &wkCAPTION_PID );
					return false;
				}

				if( fpLog ){
					if( !isEqualsList( &wkPCR_PID, &(tsp->PCR_PID) )) {
						fprintf( fpLog, "*** Change PCRPID     : %04x -> %04x\r\n", wkPCR_PID.next->PID, tsp->PCR_PID.next->PID );
					}
					if( !isEqualsList( &wkVIDEO_PID, &(tsp->VIDEO_PID) )) {
						fprintf( fpLog, "*** Change VIDEOPID   : %04x -> %04x\r\n", wkVIDEO_PID.next->PID, tsp->VIDEO_PID.next->PID );
					}
					if( !isEqualsList( &wkAUDIO_PID, &(tsp->AUDIO_PID) )) {
						int i = countList( &wkAUDIO_PID );
						int j = countList( &(tsp->AUDIO_PID) );
						if( i < j )
							i = j; 
						int PID1, PID2;
						if( findFirstNoMatchPID( &wkAUDIO_PID, &(tsp->AUDIO_PID) , &PID1, &PID2 )){
							do{
								if( PID1 == 0 ){
									fprintf( fpLog, "*** Add    AUDIOPID  : ---- -> %04x\r\n", PID2 );
								}else if( PID2 == 0 ){
									fprintf( fpLog, "*** Delete AUDIOPID  : %04x -> ----\r\n", PID1 );
								}else{
									fprintf( fpLog, "*** Change AUDIOPID  : %04x -> %04x\r\n", PID1, PID2);
								}
							}while( nextNoMatchPID( &PID1, &PID2 ));
						}
					}

					if( !isEqualsList( &wkCAPTION_PID, &(tsp->CAPTION_PID) )) {
						int i = countList( &wkCAPTION_PID );
						int j = countList( &(tsp->CAPTION_PID) );
						if( i < j )	i = j; 
						int PID1, PID2;
						if( findFirstNoMatchPID( &wkCAPTION_PID, &(tsp->CAPTION_PID), &PID1, &PID2 )){
							do{
								if( PID1 == 0 ){
									fprintf( fpLog, "*** Add    CAPTIONPID  : ---- -> %04x\r\n", PID2 );
								}else if( PID2 == 0 ){
									fprintf( fpLog, "*** Delete CAPTIONPID  : %04x -> ----\r\n", PID1 );
								}else{
									fprintf( fpLog, "*** Change CAPTIONPID  : %04x -> %04x\r\n", PID1, PID2 );
								}
							}while( nextNoMatchPID( &PID1, &PID2 ));
						}
					}
				}
				clearList( &wkPCR_PID );
				clearList( &wkVIDEO_PID );
				clearList( &wkAUDIO_PID );
				clearList( &wkCAPTION_PID );
			}
// Ver 3.5.16.7  RgAEg

			// CSɑΉׂ̈PCRɍs
			if( isPCR( tsp, nBuffPoint )){
				foundPCR = true;
				// Ver3.5.16.7---------------------------------------------
				//break;
				//---------------------------------------------------------
			}
			
			//	Payload starts							   Payload exists
			if(( tsp->nVideo[nBuffPoint + 1] & 0x40 ) && ( tsp->nVideo[nBuffPoint + 3] & 0x10 )) {
				foundPTS = isPTS( tsp, nBuffPoint );
				if( foundPTS ){
					//GOP͖Ă\Ȃ̂ŁADTSGOPƂ݂Ȃ
					foundGOP = isDTS( tsp, nBuffPoint );
					if( foundGOP ){
						tsp->numGOP++;
						foundPTS= false;
					}
					// Ver3.5.16.7---------------------------------------------
					//break;
					//---------------------------------------------------------
				}
			}
		//ver3.5.16.7------------------------------------------------------------
		//}while( !foundPCR && !foundPTS || !foundGOP );	// while
		}while( !foundPCR && !foundPTS && !foundGOP );	// while
		//-----------------------------------------------------------------------
		if( 0 == readSize )
			break;
		
		//Ver3.5.16.7-------------------------------------------------------------
		//if( foundPCR ){
		//	setPCR( tsp, nBuffPoint );
		//}
		//else if( foundGOP ){
		//	setGOP( tsp, nBuffPoint );
		//}
		//else if( foundPTS ){
		//	setPTS( tsp, nBuffPoint );
		//}
		if( foundPCR ){
			setPCR( tsp, nBuffPoint );
		}
		if( foundGOP ){
			setGOP( tsp, nBuffPoint );
		}
		if( foundPTS ){
			setPTS( tsp, nBuffPoint );
		}
		//---------------------------------------------------------------------------
	}

	return true;

}

bool isPTS( tsPACKET* tsp, int nBuffPoint )
{
	int iPPID = ((tsp->nVideo[nBuffPoint + 1] & 0x1f) << 8 ) + tsp->nVideo[nBuffPoint + 2];
	if( findList( &(tsp->VIDEO_PID), iPPID ) || findList( &(tsp->AUDIO_PID), iPPID) || findList( &(tsp->CAPTION_PID), iPPID )){
		//A_ve[VĂpPbg
		tsp->adpBytes = 0;
		if( tsp->nVideo[nBuffPoint + 3] & 0x20 ){
			tsp->adpBytes = tsp->nVideo[nBuffPoint + 4] + 1;
		}
 		//if( tsp->nVideo[nBuffPoint + 3] & 0x10 ){	   //payload exists
		//pPbgX^[gR[h(000001)
		if( 0 == tsp->nVideo[nBuffPoint + tsp->adpBytes + 4] + tsp->nVideo[nBuffPoint + tsp->adpBytes + 5]){
			if( 1 == tsp->nVideo[nBuffPoint + tsp->adpBytes + 6] ){ 
				if( 0x80 == (tsp->nVideo[nBuffPoint + tsp->adpBytes + 10] & 0xc0) ){
					//x = nVideo(nBuffPoint + adpBytes + 13) And &HF0		//PTS +DTS
					if(( tsp->nVideo[nBuffPoint + tsp->adpBytes + 11] & 0xc0 ) & 0x80 ){	//PTS=&H80 DTS=&H40
						return true;
					}
				  }
			}
		}
		//}
	}
	return false;

}

bool isDTS( tsPACKET* tsp, int nBuffPoint )
{
	//A_ve[VĂpPbg
	//DTSGOPładpBytes͓(pPbgȂ̂)
	//int x = tsp->nVideo[nBuffPoint + adpBytes + 11] & 0xc0;	//PTS=&H80 DTS=&H40
	if(( tsp->nVideo[nBuffPoint + tsp->adpBytes + 11] & 0xc0 ) & 0x40 ){	//DTS
		return true;
	}
	return false;

}

void setPCR( tsPACKET* tsp, int nBuffPoint )
{
	//PCRݒ
	tsp->nowValuePCR = getValuePCR(tsp->nVideo,nBuffPoint);
	tsp->setValuePCR = tsp->nowValuePCR - tsp->difValueGOPPTSBASE * 300;

	if( 0x258000000D3LL < tsp->setValuePCR ){
		//&H1FFFFFFFF*300+&H1FF=&H258000000D3
		tsp->setValuePCR = tsp->nowValuePCR - tsp->prevdifValueGOPPTSBASE * 300;
	}
	setPCRtoArray(tsp->nVideo,nBuffPoint, tsp->setValuePCR);
			
	if( fpLog ){
		fprintf( fpLog, "PCR   : %13lld, %13lld, %13lld, %13lld\r\n", tsp->nowValuePCR, tsp->nowValuePCR / 300, tsp->difValueGOPPTSBASE, tsp->setValuePCR / 300);
	}

}

void setGOP( tsPACKET* tsp, int nBuffPoint )
{
	//PTS̏(GOP)
	__int64	prevValueGOPPTS = tsp->nowValueGOPPTS;
	tsp->nowValueGOPPTS = getValuePTS( tsp->nVideo, nBuffPoint, tsp->adpBytes );
	__int64	difValueGOPPTS = tsp->nowValueGOPPTS - prevValueGOPPTS;

	if( ( 1 < tsp->numGOP) &&  (900000 < abs(difValueGOPPTS) )){  //Ȃ or bvAEhƔf
		//PTS90kHz̃JE^Ȃ̂900001b
		if( 900000 < (tsp->nowValueGOPPTS + 0x1FFFFFFFFLL - prevValueGOPPTS )){
			// Ȃ
			tsp->prevdifValueGOPPTSBASE = tsp->difValueGOPPTSBASE;
			tsp->difValueGOPPTSBASE = tsp->nowValueGOPPTS - (tsp->lastPTSDTS + 9009);
			//9009͎l(100.1ms ǂ̋ǂ(CS͈Ⴄ悤)

			//JE^1i߂
			int iPPID = ((tsp->nVideo[nBuffPoint + 1] & 0x1f) << 8 ) + tsp->nVideo[nBuffPoint + 2];
			(tsp->roundCounter[iPPID])++;
			if( 15 < tsp->roundCounter[iPPID] ){
				tsp->roundCounter[iPPID] = 0;
			}
			tsp->nVideo[nBuffPoint + 3] = (tsp->nVideo[nBuffPoint + 3] & 0xf0) + tsp->roundCounter[iPPID];
			
			if( fpLog  ){
				fprintf( fpLog, "********* Joint GOP *********\r\n");
				fprintf( fpLog, "GOPPTS: %13lld, %13lld\r\n", tsp->prevdifValueGOPPTSBASE, tsp->difValueGOPPTSBASE);
				//fprintf( fpLog, "CHGPCR: %13lld, %13lld, %13lld, %13lld\r\n", tsp->setValuePCR, tsp->setValuePCR / 300, tsp->nowValuePCR, tsp->nowValuePCR / 300);
			}

		} else {
			// wrap around bvAEh
			tsp->prevdifValueGOPPTSBASE = tsp->difValueGOPPTSBASE;
			tsp->difValueGOPPTSBASE -= 0x1FFFFFFFFLL;

			if( fpLog ){
				fprintf( fpLog, "********* wrap around GOP *********\r\n");
			}
		}
	}

	tsp->bGOP = true;
	setPTS( tsp, nBuffPoint );
	setDTS( tsp, nBuffPoint );
	tsp->bGOP = false;

	if( fpLog ){
		fprintf( fpLog, "V-GOP :                %13lld, %13lld, %13lld, %13lld, %13lld\r\n", tsp->nowValueGOPPTS, tsp->difValueGOPPTSBASE, tsp->nowValueGOPPTS - tsp->difValueGOPPTSBASE, prevValueGOPPTS, abs(difValueGOPPTS));
	}

}

void setPTS( tsPACKET* tsp, int nBuffPoint )
{
	//PTS
	__int64	nowValuePTS = getValuePTS( tsp->nVideo, nBuffPoint, tsp->adpBytes );
	__int64	setValuePTS = nowValuePTS - tsp->difValueGOPPTSBASE;
	if( 0x1FFFFFFFFLL < setValuePTS ){
		setValuePTS = nowValuePTS - tsp->prevdifValueGOPPTSBASE;
	}
// Ver 3.5.16.7  (C-PTS Cp) ǉ
	__int64 CAPTIONstartPCR = ( tsp->startPCR ) / 300;
	int iPPID = ((tsp->nVideo[nBuffPoint + 1] & 0x1f) << 8 ) + tsp->nVideo[nBuffPoint + 2];
	if( findList( &(tsp->CAPTION_PID), iPPID )) {
		if( CAPTIONstartFlag ) {
			if( CAPTIONstartPCR < nowValuePTS ) {
				CAPTIONstartPTS = nowValuePTS;
				CAPTIONstartFlag = false;
			}
		}
		setValuePTS = CAPTIONstartPCR + ( nowValuePTS - CAPTIONstartPTS ) + 45000;	// +500ms
	}
// Ver 3.5.16.7  (C-PTS Cp)
	setPTStoArray( tsp->nVideo, nBuffPoint, setValuePTS, tsp->adpBytes );

	if( isDTS( tsp, nBuffPoint ))
		tsp->lastPTSDTS = setValuePTS;

	if( fpLog && !tsp->bGOP ){
		int iPPID = ((tsp->nVideo[nBuffPoint + 1] & 0x1f) << 8 ) + tsp->nVideo[nBuffPoint + 2];
		if( findList( &(tsp->VIDEO_PID), iPPID ))
			fprintf( fpLog, "V-PTS :                %13lld, %13lld, %13lld\r\n", nowValuePTS, tsp->difValueGOPPTSBASE, setValuePTS);
		else if( findList( &(tsp->AUDIO_PID), iPPID ))
			fprintf( fpLog, "A-PTS :                %13lld, %13lld, %13lld\r\n", nowValuePTS, tsp->difValueGOPPTSBASE, setValuePTS);
		else if( findList( &(tsp->CAPTION_PID), iPPID ))
			fprintf( fpLog, "C-PTS :                %13lld, %13lld, %13lld\r\n", nowValuePTS, tsp->difValueGOPPTSBASE, setValuePTS);
	
	}

}

void setDTS( tsPACKET* tsp, int nBuffPoint )
{
	//DTS̐ݒ
	__int64	nowValueDTS = getValueDTS( tsp->nVideo, nBuffPoint, tsp->adpBytes );
	__int64	setValueDTS = nowValueDTS - tsp->difValueGOPPTSBASE;
	if( 0x1FFFFFFFFLL < setValueDTS ){
		setValueDTS = nowValueDTS - tsp->prevdifValueGOPPTSBASE;
	}
	setDTStoArray( tsp->nVideo, nBuffPoint, setValueDTS, tsp->adpBytes );

}

void clearListMEM( tsPACKET* tsp )
{
	clearList( &(tsp->PCR_PID) );
	clearList( &(tsp->PMT_PID) );
	clearList( &(tsp->VIDEO_PID) );
	clearList( &(tsp->AUDIO_PID) );
	clearList( &(tsp->CAPTION_PID) );

}

void initList( tsPACKET* tsp )
{
	tsp->PCR_PID.next = NULL;
	tsp->PMT_PID.next = NULL;
	tsp->VIDEO_PID.next = NULL;
	tsp->AUDIO_PID.next = NULL;
	tsp->CAPTION_PID.next = NULL;

}